import axios from 'axios'

const newUrl = '/eiru_purchases/new'

const createUrl = '/eiru_purchases/create'

const actions = {
    /**
     * Get all resources to init purchase app
     * @param {*} param0 
     */
    initPurchase({ dispatch }) {
        return axios.get(newUrl).then(response => {
            dispatch('explodeData', response.data)
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    explodeData({ commit }, payload) {
        Object.keys(payload).forEach(key => {
            commit('set'.concat(key[0].toUpperCase()).concat(key.slice(1)), payload[key])
        })
        // commit('setDate', payload.date)
        // commit('setUser', payload.user)
        // commit('setCurrencies', payload.currencies)
        // commit('setJournals', payload.journals)
        // commit('setSuppliers', payload.suppliers)
        // commit('setProducts', payload.products)
        // commit('setPickingTypes', payload.pickingTypes)
        // commit('setPaymentTerms', payload.paymentTerms)
    },
    /**
     * Send data to create concrete purchase
     * @param {*} param0 
     */
    createPurchase({ commit, dispatch }) {
        return axios.post(createUrl, {

        }).then(response => {
            dispatch('resetPurchase')
        }).catch(error => {
            console.log(error)
        })
    },
    /**
     * Reset all default app state 
     * @param {*} param0 
     */
    resetPurchase({ getters }) {
        console.log('reseting')
    }
}

export default actions