const state = {
    paymentTerm: {
        default: [],
        values: this.default
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    paymentTerms(state) {
        return state.paymentTerm.values
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setPaymentTerms(state, payload) {
        state.paymentTerm.values = [...payload]
    }
}

const actions = {
    setPaymentTerms({ commit }, payload) {
        commit('setPaymentTerms', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}