import axios from 'axios'

const url = '/eiru_purchases/new'

const state = {
    product: {
        default: [],
        values: []
    }
}

const getters = {
    /**
     * 
     * @param {*} state 
     */
    products(state) {
        return state.product.values
    }
}

const mutations = {
    /**
     * 
     * @param {*} state 
     * @param {*} payload 
     */
    setProducts(state, payload) {
        state.product.values = [...payload]
    }
}

const actions = {
    /**
     * 
     * @param {*} param0 
     * @param {*} payload 
     */
    setProducts({ commit }, payload) {
        commit('setProducts', payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}